<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "campaign".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Campaign".
 *
 * Columns in table "campaign" available as properties of the model,
 * followed by relations of table "campaign" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $template_id
 *
 * @property CampaignEmail[] $campaignEmails
 */
abstract class BaseCampaign extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'campaign';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Campaign|Campaigns', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, template_id', 'required'),
            array('name, template_id', 'length', 'max' => 45),
            array('id, name, template_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'campaignEmails' => array(self::HAS_MANY, 'CampaignEmail', 'campaign_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'template_id' => Yii::t('app', 'Template'),
            'campaignEmails' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('template_id', $this->template_id, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
